minor bug fix
[distro-setup] / distro-end
index 6c0f446642d15916512a929ce22caad4ef9a71f2..317852291a0d21fb83764c2d7225f0c5a0f5dd66 100755 (executable)
@@ -18,7 +18,6 @@ _errcatch_cleanup() {
 # shellcheck source=./pkgs
 source $src/pkgs
 
-set -x
 exec &> >(sudo tee -a /var/log/distro-end)
 echo "$0: $(date): starting now)"
 # see example of usage to understand.
@@ -27,12 +26,28 @@ end_msg() {
   IFS= read -r -d '' y  ||:
   end_msg_var+="$y"
 }
-die() {
-  printf "$0: %s\n" "$*" >&2; exit 1
+end() {
+  e "$end_msg_var"
+  echo 0 >~/.local/distro-end
+  if $pending_reboot; then
+    echo "$0: pending reboot and then finished. doing it now."
+    s reboot now
+  else
+    echo "$0: $(date): ending now)"
+  fi
+  exit 0
 }
-spa() { # simple package add
-  simple_packages+=($@)
+pre="${0##*/}:"
+s() {
+  printf "s %s\n" "$*"
+  SUDOD="$PWD" sudo -i "$@";
 }
+sd() {
+  s dd of="$1" 2>/dev/null
+}
+m() { printf "$pre %s\n"  "$*"; "$@"; }
+e() { printf "$pre %s\n"  "$*"; }
+err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $0: $*" >&2; }
 distro=$(distro-name)
 codename=$(debian-codename)
 codename_compat=$(debian-codename-compat)
@@ -53,23 +68,12 @@ s debconf-set-selections <<EOF
 popularity-contest popularity-contest/participate boolean true
 EOF
 
-########### begin section including li ################
+########### begin section including linode ################
 pi ${p2[@]}
 
 
 conflink
 
-case $distro in
-  arch) sgo cronie ;;
-esac
-
-case $distro in
-  arch) sgo atd ;;
-  # not needed for deb, dependency of at.
-esac
-
-
-
 # no equivalent in other distros:
 if isdeb && pcheck apt-file; then
   # this condition is just a speed optimization
@@ -86,12 +90,12 @@ case $distro in
     # i'd rather disable the service than comment the init file
     # this says disabling the service, it will still get restarted
     # but this script doesn't do anything on restart, so it should be fine
-    s dd of=/var/run/motd.dynamic if=/dev/null
+    s truncate -s0 /var/run/motd.dynamic
     ;;
   trisquel|ubuntu)
     # this isn't a complete solution. It still shows me when updates are available,
     # but it's no big deal.
-    s rm -f /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
+    s rm -fv /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
     ;;
 esac
 
@@ -109,22 +113,22 @@ elif [[ $codename_compat == xenial ]]; then
   l="deb http://ppa.launchpad.net/certbot/certbot/ubuntu xenial main"
   if ! grep -xFq "$l" /etc/apt/sources.list{,.d/*.list}; then
     s add-apt-repository -y ppa:certbot/certbot ||:
-    p update
+    p update
   fi
   pi python-certbot-apache
 else
-  die "distro unknown for certbot"
+  err "distro unknown for certbot"
 fi
 # make a version of the certbot timer that emails me.
 x=/systemd/system/certbot
-$sed -r -f - /lib$x.timer <<'EOF' |s dd of=/etc${x}mail.timer
+$sed -r -f - /lib$x.timer <<'EOF' |s/etc${x}mail.timer
 s,^Description.*,\0 mail version,
 EOF
-$sed -r -f - /lib$x.service <<'EOF' |s dd of=/etc${x}mail.service
+$sed -r -f - /lib$x.service <<'EOF' |s/etc${x}mail.service
 s,(ExecStart=)(/usr/bin/certbot),\1/a/bin/log-quiet/sysd-mail-once certbotmail \2 --renew-hook /a/bin/distro-setup/certbot-renew-hook,
 EOF
 ser daemon-reload
-sgo certbotmail.timer
+sgo certbotmail.timer
 ### end certbot install ###
 
 
@@ -163,7 +167,7 @@ case $(debian-codename) in
   # needed for debootstrap scripts for fai since fai requires debian
   flidas)
     curl http://archive.ubuntu.com/ubuntu/project/ubuntu-archive-keyring.gpg | s apt-key add -
-    s dd of=/etc/apt/preferences.d/flidas-xenial <<EOF
+    s/etc/apt/preferences.d/flidas-xenial <<EOF
 Package: *
 Pin: release a=xenial
 Pin-Priority: -100
@@ -176,14 +180,15 @@ Package: *
 Pin: release a=xenial-security
 Pin-Priority: -100
 EOF
-    s dd of=/etc/apt/sources.list.d/xenial.list 2>/dev/null <<EOF
+    s/etc/apt/sources.list.d/xenial.list 2>/dev/null <<EOF
 deb http://us.archive.ubuntu.com/ubuntu/ xenial main
 deb http://us.archive.ubuntu.com/ubuntu/ xenial-updates main
 deb http://us.archive.ubuntu.com/ubuntu/ xenial-security main
 EOF
 
-    s apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
-    s dd of=/etc/apt/preferences.d/flidas-bionic <<EOF
+    if ! apt-key list | grep /C0B21F32 &>/dev/null; then
+      s apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
+      sd /etc/apt/preferences.d/flidas-bionic <<EOF
 Package: *
 Pin: release a=bionic
 Pin-Priority: -100
@@ -196,10 +201,11 @@ Package: *
 Pin: release a=bionic-security
 Pin-Priority: -100
 EOF
+    fi
 
     # better to run btrfs-progs which matches our kernel version
     # (note, renamed from btrfs-tools)
-    s dd of=/etc/apt/preferences.d/btrfs-progs <<EOF
+    s/etc/apt/preferences.d/btrfs-progs <<EOF
 Package: btrfs-progs libzstd1
 Pin: release a=bionic
 Pin-Priority: 1005
@@ -224,20 +230,22 @@ EOF
     if ! diff -q $t $f; then
       s cp $t $f
       s chmod 644 $f
-      p update
+      p update
     fi
 
     # no special reason, but its better for btrfs-progs to
     # be closer to our kernel version
     pi btrfs-progs
 
-    t=$(mktemp -d)
-    cd $t
-    aptitude download debootstrap/xenial
-    ex ./*
-    s cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
+    if [[ ! -e /usr/share/debootstrap/scripts/xenial ]]; then
+      t=$(mktemp -d)
+      cd $t
+      m aptitude download debootstrap/xenial
+      m ex ./*
+      s cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
+    fi
 
-    s dd of=/etc/apt/preferences.d/flidas-etiona <<EOF
+    s/etc/apt/preferences.d/flidas-etiona <<EOF
 Package: *
 Pin: release a=etiona
 Pin-Priority: -100
@@ -265,18 +273,18 @@ EOF
     f=/etc/apt/sources.list.d/etiona.list
     if ! diff -q $t $f; then
       s cp $t $f
-      s chmod 644 $f
-      p update
+      s chmod 644 $f
+      p update
     fi
 
-    s dd of=/etc/apt/preferences.d/debian-goodies <<EOF
+    s/etc/apt/preferences.d/debian-goodies <<EOF
 Package: debian-goodies
 Pin: release n=etiona
 Pin-Priority: 1005
 EOF
 
 
-    s dd of=/etc/apt/preferences.d/flidas-buster <<EOF
+    s/etc/apt/preferences.d/flidas-buster <<EOF
 Package: *
 Pin: release n=buster
 Pin-Priority: -100
@@ -289,14 +297,14 @@ EOF
     # dont use buster because it causes dist-upgrade to think its downgrading
     # packages while really just reinstalling the same version.
     f=/etc/apt/apt.conf.d/01iank
-    rm -f $f
+    s rm -fv $f
     #         # stupid buster uses some key algorithm not supported by flidas gpg that apt uses.
-    #         s dd of=/etc/apt/apt.conf.d/01iank <<'EOF'
+    #         s/etc/apt/apt.conf.d/01iank <<'EOF'
     # Acquire::AllowInsecureRepositories "true";
     # EOF
 
     f=/etc/apt/sources.list.d/buster.list
-    rm -f $f
+    s rm -fv $f
     #         t=$(mktemp)
     #         cat >$t <<EOF
     # deb http://http.us.debian.org/debian buster main
@@ -317,9 +325,9 @@ EOF
     # newer version needed for false positive in checkrestart.
     # I did buster at first, but other problem above with having
     # buster repos. not sure if the false positive exists in etiona.
-    p install -y --allow-unauthenticated debian-goodies
+    pi debian-goodies
 
-    s dd of=/etc/apt/preferences.d/shellcheck <<EOF
+    s/etc/apt/preferences.d/shellcheck <<EOF
 Package: shellcheck
 Pin: release a=etiona
 Pin-Priority: 1005
@@ -333,7 +341,7 @@ Pin: release a=etiona-security
 Pin-Priority: 1005
 EOF
 
-    s dd of=/etc/apt/preferences.d/bash <<EOF
+    s/etc/apt/preferences.d/bash <<EOF
 Package: bash
 Pin: release a=etiona
 Pin-Priority: 1005
@@ -358,7 +366,7 @@ esac
 ######### end flidas pinned packages ######
 
 ##### begin automatic upgrades (after checkrestart has been installed) ####
-s dd of=/etc/apt/apt.conf.d/10periodic <<'EOF'
+s/etc/apt/apt.conf.d/10periodic <<'EOF'
 # this file was mostly just comments.
 APT::Periodic::Update-Package-Lists "1";
 APT::Periodic::Download-Upgradeable-Packages "1";
@@ -366,7 +374,7 @@ APT::Periodic::AutocleanInterval "7";
 APT::Periodic::Unattended-Upgrade "1";
 EOF
 
-s dd of=/etc/apt/apt.conf.d/50unattended-upgrades  <<EOF
+s/etc/apt/apt.conf.d/50unattended-upgrades  <<EOF
 # fyi: default file has comments about available options,
 # you may want to read that, do pkx unattended-upgrades
 Unattended-Upgrade::Mail "root";
@@ -382,7 +390,7 @@ EOF
 # old names, too verbose
 s rm -f /etc/cron.d/unattended-upgrade-reboot /usr/local/bin/zelous-unattended-reboot
 
-s dd of=/etc/cron.d/myupgrade <<'EOF'
+s/etc/cron.d/myupgrade <<'EOF'
 # Setup reboots when running outdated stuff, unattended upgrades happen
 # at 6 am + rand(60 min).
 20 7 * * * root /usr/local/bin/myupgrade | /usr/local/bin/log-once -1 myupgrade
@@ -394,22 +402,25 @@ EOF
 
 ###### begin website setup
 case $HOSTNAME in
-  li)
-
-    pi bind9
+  li|l2)
     f=/var/lib/bind/db.b8.nz
     if [[ ! -e $f ]]; then
       ser stop bind9
-      rm -f $f.jnl
-      install -m 644 -o bind -g bind /p/c/machine_specific/li/bind-initial/db.b8.nz $f
+      s rm -fv $f.jnl
+      s install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
       ser restart bind9
     fi
+    ;;&
+  l2)
+    end
+    ;;
+  li)
 
     case $HOSTNAME in
       li) domain=iankelling.org ;;
     esac
-    /a/h/setup.sh $domain
-    /a/h/build.rb
+    /a/h/setup.sh $domain
+    /a/h/build.rb
 
     # start mumble only when im going to use it, since i dont use it much
     pi-nostart mumble-server
@@ -418,9 +429,9 @@ case $HOSTNAME in
     # do certificate to avoid warning about unsigned cert,
     # which is overkill for my use, but hey, I'm cool, I know
     # how to do this.
-    web-conf apache2 mumble.iankelling.org
-    s rm -f /etc/apache2/sites-enabled/mumble.iankelling.org
-    sudo -i <<'EOF'
+    web-conf apache2 mumble.iankelling.org
+    s rm -fv /etc/apache2/sites-enabled/mumble.iankelling.org
+    s <<'EOF'
 export RENEWED_LINEAGE=/etc/letsencrypt/live/mumble.iankelling.org
 /a/bin/distro-setup/certbot-renew-hook
 EOF
@@ -434,7 +445,7 @@ EOF
     # https://community.openvpn.net/openvpn/wiki/IPv6
     # and man openvpn
 
-    vpn-server-setup -rd 2600:3c00:e000:280::1/64 2600:3c00::f03c:91ff:feb4:0bf3
+    vpn-server-setup -rd 2600:3c00:e000:280::1/64 2600:3c00::f03c:91ff:feb4:0bf3
     s tee /etc/openvpn/client-config/mail <<'EOF'
 ifconfig-push 10.8.0.4 255.255.255.0
 ifconfig-ipv6-push 2600:3c00:e000:280::2/64
@@ -460,13 +471,13 @@ ExecStop=/a/bin/distro-setup/vpn-mail-forward stop
 WantedBy=$vpn_service.service
 EOF
     ser daemon-reload
-    sgo vpnmail.service
+    sgo vpnmail.service
     # needed for li's local mail delivery.
     tu /etc/hosts <<<"10.8.0.4 mail.iankelling.org"
-    sgo $vpn_service
+    sgo $vpn_service
     # setup let's encrypt cert
-    web-conf apache2 mail.iankelling.org
-    s rm /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
+    web-conf apache2 mail.iankelling.org
+    s rm -fv /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
     ser reload apache2
 
     domain=cal.iankelling.org
@@ -537,7 +548,7 @@ EOF
     s useradd --create-home -d /var/lib/znc --system --shell /sbin/nologin --comment "Account to run ZNC daemon" --user-group znc || [[ $? == 9 ]] # 9 if it exists already
     s chmod 700 /var/lib/znc
     s chown -R znc:znc /var/lib/znc
-    s dd of=/etc/systemd/system/znc.service 2>/dev/null <<'EOF'
+    s/etc/systemd/system/znc.service 2>/dev/null <<'EOF'
 [Unit]
 Description=ZNC, an advanced IRC bouncer
 After=network-online.target
@@ -550,13 +561,13 @@ User=znc
 WantedBy=multi-user.target
 EOF
     ser daemon-reload
-    sgo znc
+    # avoid restarting if possible, reconnecting to irc is annoying.
+    if [[ $(ser is-active znc) != active ]]; then
+      m sgo znc
+    fi
     ###### stop znc setup #####
 
-
-
-    echo "$0: $(date): ending now)"
-    exit 0
+    end
     ;;
 esac
 ###### end website setup
@@ -590,17 +601,12 @@ esac
 # dependent packages.
 pi ${pall[@]} $(apt-cache search ruby[.0-9]+-doc| awk '{print $1}') $(apt-cache depends gcc|grep -i suggests:| awk '{print $2}') $($src/distro-pkgs)
 
-if ! type pip; then
-  x=$(mktemp)
-  wget -O$x https://bootstrap.pypa.io/get-pip.py
-  python3 $x --user
-fi
 
-sgo fsf-vpn-dns-cleanup
+sgo fsf-vpn-dns-cleanup
 
 
-# website is dead june 14 2019
-s rm -f /etc/apt/sources.list.d/iridium-browser.list
+# website is dead june 14 2019. back in october, but meh
+s rm -fv /etc/apt/sources.list.d/iridium-browser.list
 # case $distro in
 #   debian)
 #     pi chromium ;;
@@ -643,7 +649,7 @@ s rm -f /etc/apt/sources.list.d/iridium-browser.list
 # done
 
 # key already exists, so this won't generate one, just the configs.
-vpn-server-setup -rds
+vpn-server-setup -rds
 s tee -a /etc/openvpn/server/server.conf <<'EOF'
 push "dhcp-option DNS 10.0.0.1"
 push "route 10.0.0.0 255.255.0.0"
@@ -657,7 +663,7 @@ if [[ $HOSTNAME == tp ]]; then
   else
     vpn_service=openvpn@server
   fi
-  sgo $vpn_service
+  sgo $vpn_service
 fi
 ### end vpn server setup
 
@@ -665,7 +671,7 @@ fi
 ##### rss2email
 # note, see bashrc for more documentation.
 pi rss2email
-s dd of=/etc/systemd/system/rss2email.service <<'EOF'
+s/etc/systemd/system/rss2email.service <<'EOF'
 [Unit]
 Description=rss2email
 After=multi-user.target
@@ -678,7 +684,7 @@ Type=oneshot
 # we pass options to use different location.
 ExecStart=/a/bin/log-quiet/sysd-mail-once -288 rss2email r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg run
 EOF
-s dd of=/etc/systemd/system/rss2email.timer <<'EOF'
+s/etc/systemd/system/rss2email.timer <<'EOF'
 [Unit]
 Description=rss2email
 
@@ -696,7 +702,7 @@ s systemctl daemon-reload
 
 ######### begin  pump.io periodic backup #############
 if [[ $HOSTNAME == frodo ]]; then
-  s dd of=/etc/systemd/system/pumpbackup.service <<'EOF'
+  s/etc/systemd/system/pumpbackup.service <<'EOF'
 [Unit]
 Description=pump li backup
 After=multi-user.target
@@ -706,7 +712,7 @@ User=iank
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once pump-backup /a/bin/distro-setup/pump-backup
 EOF
-  s dd of=/etc/systemd/system/pumpbackup.timer <<'EOF'
+  s/etc/systemd/system/pumpbackup.timer <<'EOF'
 [Unit]
 Description=pump li backup hourly
 
@@ -716,15 +722,15 @@ OnCalendar=hourly
 [Install]
 WantedBy=timers.target
 EOF
-  s systemctl daemon-reload
-  sgo pumpbackup.timer
+  ser daemon-reload
+  sgo pumpbackup.timer
 fi
 #########  end  pump.io periodic backup #############
 
 
 ######### begin irc periodic backup #############
 if [[ $HOSTNAME == frodo ]]; then
-  s dd of=/etc/systemd/system/ircbackup.service <<'EOF'
+  s/etc/systemd/system/ircbackup.service <<'EOF'
 [Unit]
 Description=irc li backup
 After=multi-user.target
@@ -734,7 +740,7 @@ User=iank
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once irc-backup rsync -rlptDhSAX root@iankelling.org:/var/lib/znc/moddata/log/iank/freenode/ /k/irclogs
 EOF
-  s dd of=/etc/systemd/system/ircbackup.timer <<'EOF'
+  s/etc/systemd/system/ircbackup.timer <<'EOF'
 [Unit]
 Description=irc li backup hourly
 
@@ -752,10 +758,6 @@ fi
 ######### end irc periodic backup #############
 
 
-# https://github.com/jlebon/textern
-cd /a/opt/textern
-make native-install USER=1
-
 case $distro in
   debian|trisquel|ubuntu)
     # suggests resolvconf package. installing it here is redundant, but make sure anyways.
@@ -767,18 +769,7 @@ case $distro in
   *) pi openvpn;;
 esac
 
-/a/bin/distro-setup/radicale-setup
-
-## android studio setup
-# this contains the setting for android sdk to point to
-# /a/opt/androidsdk, which is asked upon first run
-lnf /a/opt/.AndroidStudio2.2 ~
-# android site says it needs a bunch of packages for ubuntu,
-# but I googled for debian, and someone says you just need lib32stdc++6 plus the
-# jdk
-# https://pid7007blog.blogspot.com/2015/07/installing-android-studio-in-debian-8.html
-# see w.org for more android studio details
-spa lib32stdc++6 default-jdk
+m /a/bin/distro-setup/radicale-setup
 
 
 ############# begin syncthing setup ###########
@@ -788,29 +779,24 @@ if [[ $HOSTNAME == frodo ]]; then
   # and just run it in one place instead of the normal having a
   # separate config.  I lean toward using the same config, since btrfs
   # syncs between comps.
-  case $distro in
-    arch) pi syncthing ;;
-    trisquel|ubuntu|debian)
-      # testing has relatively up to date packages
-      if ! isdebian-testing; then
-        # based on error when doing apt-get update:
-        # E: The method driver /usr/lib/apt/methods/https could not be found.
-        pi apt-transport-https
-        # google led me here:
-        # https://apt.syncthing.net/
-        curl -s https://syncthing.net/release-key.txt | sudo apt-key add -
-        s="deb http://apt.syncthing.net/ syncthing release"
-        if [[ $(cat /etc/apt/sources.list.d/syncthing.list) != "$s" ]]; then
-          echo "$s" | s dd of=/etc/apt/sources.list.d/syncthing.list
-          p update
-        fi
-      fi
-      pi syncthing
-      ;;
-  esac
-  lnf -T /w/syncthing /home/iank/.config/syncthing
+  # testing has relatively up to date packages
+  if ! isdebian-testing; then
+    # based on error when doing apt-get update:
+    # E: The method driver /usr/lib/apt/methods/https could not be found.
+    pi apt-transport-https
+    # google led me here:
+    # https://apt.syncthing.net/
+    curl -s https://syncthing.net/release-key.txt | sudo apt-key add -
+    s="deb http://apt.syncthing.net/ syncthing release"
+    if [[ $(cat /etc/apt/sources.list.d/syncthing.list) != "$s" ]]; then
+      echo "$s" | sd /etc/apt/sources.list.d/syncthing.list
+      p update
+    fi
+  fi
+  pi syncthing
+  m lnf -T /w/syncthing /home/iank/.config/syncthing
   ser daemon-reload # syncthing likely not properly packaged
-  sgo syncthing@iank # runs as iank
+  sgo syncthing@iank # runs as iank
 
   # these things persist in ~/.config/syncthing, which I save in
   # /w/syncthing (not in /p, because syncthing should continue to
@@ -869,11 +855,11 @@ esac
 
 
 # sakura config is owned by ian
-reset-sakura
-reset-konsole
-sudo -u user2 -i reset-konsole
+reset-sakura
+reset-konsole
+sudo -u user2 -i reset-konsole
 # user2 xscreensaver we don't want to reset
-reset-xscreensaver
+reset-xscreensaver
 
 
 # this would install from cabal for newer / consistent version across os, but it screws up xmonad, so disabled for now.
@@ -884,22 +870,22 @@ reset-xscreensaver
 # also, i assume syncing this between machines somehow messed thin
 #lnf -T /m/arbtt-capture.log ~/.arbtt/capture.log
 
-primary-setup
+primary-setup
 
 if [[ ! -e ~/.linphonerc && -e /p/.linphonerc-initial ]]; then
-  cp /p/.linphonerc-initial ~/.linphonerc
+  cp /p/.linphonerc-initial ~/.linphonerc
 fi
 
 
 ### begin spd install
 pi libswitch-perl libdigest-md5-file-perl libgnupg-interface-perl
 t=$(mktemp)
-wget -O $t http://mirror.fsf.org/fsfsys-trisquel/fsfsys-trisquel/pool/main/s/spd-perl/spd-perl_0.2-1_amd64.deb
+wget -O $t http://mirror.fsf.org/fsfsys-trisquel/fsfsys-trisquel/pool/main/s/spd-perl/spd-perl_0.2-1_amd64.deb
 s dpkg -i $t
-rm $t
+rm $t
 # this guesses at the appropriate directory, adjust if needed
 perldir=(/usr/lib/x86_64-linux-gnu/perl/5.*)
-sudo ln -sf ../../../perl/5.18.2/SPD/ ${perldir[0]}
+sudo ln -sf ../../../perl/5.18.2/SPD/ ${perldir[0]}
 # newer distro had gpg2 as default, older one, flidas, need to make it that way
 gpgpath=$(which gpg2)
 if [[ $x ]]; then
@@ -909,15 +895,6 @@ fi
 ### end spd install
 
 
-if [[ $HOSTNAME == kw ]]; then
-  cat <<'EOF'
-NOTE: after this finishes, i did
-s nmtui-connect
-# remove br from auto:
-s vim /etc/network/interfaces
-EOF
-fi
-
 # nagstamon setting which were set through the ui
 # in filters tab:
 # all unknown sources
@@ -947,15 +924,10 @@ fi
 # but i'm just going to rely on the webpage plus sms for now.
 
 
-case $distro in
-  debian|trisquel|ubuntu)
-    # it asks if it should make users in it's group capture packets without root,
-    # which is arguably more secure than running wireshark as root. default is no,
-    # which is what i prefer, since I plan to use tcpdump to input to wireshark.
-    s DEBIAN_FRONTEND=noninteractive pi wireshark-gtk
-    ;;
-  # others unknown
-esac
+# it asks if it should make users in it's group capture packets without root,
+# which is arguably more secure than running wireshark as root. default is no,
+# which is what i prefer, since I plan to use tcpdump to input to wireshark.
+s DEBIAN_FRONTEND=noninteractive pi wireshark-gtk
 
 # /run and /dev/shm are listed as required for pulseaudio. All 4 in the group
 # listed in the default config as suggested.
@@ -990,7 +962,7 @@ mkschroot() {
   fi
   apps=($@)
   d=/nocow/schroot/$n
-  s dd of=/etc/schroot/chroot.d/$n.conf <<EOF
+  s/etc/schroot/chroot.d/$n.conf <<EOF
 [$n]
 description=$n
 type=directory
@@ -1011,7 +983,7 @@ EOF
   fi
   s cp -P {,$d}/etc/localtime
 }
-s dd of=/etc/systemd/system/schrootupdate.service <<'EOF'
+s/etc/systemd/system/schrootupdate.service <<'EOF'
 [Unit]
 Description=schrootupdate
 After=multi-user.target
@@ -1020,7 +992,7 @@ After=multi-user.target
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once schrootupdate /a/bin/distro-setup/schrootupdate
 EOF
-s dd of=/etc/systemd/system/schrootupdate.timer <<'EOF'
+s/etc/systemd/system/schrootupdate.timer <<'EOF'
 [Unit]
 Description=schrootupdate
 
@@ -1030,15 +1002,15 @@ OnCalendar=*-*-* 04:20:00
 [Install]
 WantedBy=timers.target
 EOF
-s systemctl daemon-reload
-sgo schrootupdate.timer
+ser daemon-reload
+sgo schrootupdate.timer
 
 
 
 # for my roommate
 case $distro in
   trisquel)
-    mkschroot debian stretch firefox-esr pulseaudio chromium
+    m mkschroot debian stretch firefox-esr pulseaudio chromium
     ;;
   debian)
     pi chromium
@@ -1050,33 +1022,21 @@ s chown $USER:$USER /nocow/user
 pi anki
 
 
+####### begin transmission
+
 # adapted from /var/lib/dpkg/info/transmission-daemon.postinst
 # 450 seems likely to be unused. we need to specify one or else
 # it won't be stable across installs.
 if ! getent passwd debian-transmission > /dev/null; then
   s groupadd -g 450 debian-transmission
-  case $distro in
-    arch)
-      s useradd \
-        --system \
-        --create-home \
-        --gid 450 \
-        --uid 450 \
-        --home-dir /var/lib/transmission-daemon \
-        --shell /bin/false \
-        debian-transmission
-      ;;
-    *)
-      s adduser --quiet \
-        --gid 450 \
-        --uid 450 \
-        --system \
-        --no-create-home \
-        --disabled-password \
-        --home /var/lib/transmission-daemon \
-        debian-transmission
-      ;;
-  esac
+  s adduser --quiet \
+    --gid 450 \
+    --uid 450 \
+    --system \
+    --no-create-home \
+    --disabled-password \
+    --home /var/lib/transmission-daemon \
+    debian-transmission
 fi
 # We want group writable stuff from transmission.
 # However, after setting this, I learn that transmission sets it's
@@ -1084,56 +1044,54 @@ fi
 # so it's set right from the beginning.
 s chfn debian-transmission -o umask=0002
 
-case $distro in
-  debian|trisquel|ubuntu)
-    # note i had to do this, which is persistent:
-    # cd /i/k
-    # s chgrp debian-transmission torrents partial-torrents
-
-    # syslog says things like
-    # 'Failed to set receive buffer: requested 4194304, got 425984'
-    # google suggets giving it even more than that
-    tu /etc/sysctl.conf<<'EOF'
+# note i had to do this, which is persistent:
+# cd /i/k
+# s chgrp debian-transmission torrents partial-torrents
+
+# syslog says things like
+# 'Failed to set receive buffer: requested 4194304, got 425984'
+# google suggets giving it even more than that
+tu /etc/sysctl.conf<<'EOF'
 net.core.rmem_max = 67108864
 net.core.wmem_max = 16777216
 EOF
-    s sysctl -p
-
-    # some reason it doesn\'t seem to start automatically anyways
-    pi-nostart transmission-daemon
-    # be extra sure its not started
-    ser disable transmission-daemon
-    ser stop transmission-daemon
-
-    # the folder was moved here after an install around 02/2017.
-    # it contains runtime data,
-    # plus a simple symlink to the config file which it\'s
-    # not worth separating out.
-    # between comps, the uid can change
-    f=/i/transmission-daemon
-    s lnf -T $f /var/lib/transmission-daemon/.config/transmission-daemon
-    if [[ -e $f ]]; then
-      s chown -R debian-transmission:debian-transmission $f
-    fi
-    for f in /i/k/partial-torrents /i/k/torrents; do
-      if [[ -e $f ]]; then
-        s chown -R debian-transmission:user2 $f
-      fi
-    done
-    s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
-    #
-    # config file documented here, and it\'s the same config
-    # for daemon vs client, so it\'s documented in the gui.
-    # https://trac.transmissionbt.com/wiki/EditConfigFiles#Options
-    #
-    # I originaly setup rpc-whitelist, but after using
-    # routing to a network namespace, it doesn\'t see the
-    # real source address, so it\'s disabled.
-    #
-    # Changed the cache-size to 256 mb, reduces disk use.
-    # It is a read & write cache.
-    #
-    s ruby <<'EOF'
+s sysctl -p
+
+# some reason it doesn\'t seem to start automatically anyways
+pi-nostart transmission-daemon
+# be extra sure its not started
+ser disable transmission-daemon
+ser stop transmission-daemon
+
+# the folder was moved here after an install around 02/2017.
+# it contains runtime data,
+# plus a simple symlink to the config file which it\'s
+# not worth separating out.
+# between comps, the uid can change
+f=/i/transmission-daemon
+s lnf -T $f /var/lib/transmission-daemon/.config/transmission-daemon
+if [[ -e $f ]]; then
+  s chown -R debian-transmission:debian-transmission $f
+fi
+for f in /i/k/partial-torrents /i/k/torrents; do
+  if [[ -e $f ]]; then
+    s chown -R debian-transmission:user2 $f
+  fi
+done
+s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
+#
+# config file documented here, and it\'s the same config
+# for daemon vs client, so it\'s documented in the gui.
+# https://trac.transmissionbt.com/wiki/EditConfigFiles#Options
+#
+# I originaly setup rpc-whitelist, but after using
+# routing to a network namespace, it doesn\'t see the
+# real source address, so it\'s disabled.
+#
+# Changed the cache-size to 256 mb, reduces disk use.
+# It is a read & write cache.
+#
+s ruby <<'EOF'
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 File.write(p, JSON.pretty_generate(JSON.parse(File.read(p)).merge({
@@ -1150,10 +1108,7 @@ File.write(p, JSON.pretty_generate(JSON.parse(File.read(p)).merge({
 "ratio-limit-enabled" => true,
 })) + "\n")
 EOF
-
-    ;;
-  # todo: others unknown
-esac
+####### end transmission
 
 
 
@@ -1163,7 +1118,7 @@ if [[ ! -e /lib/systemd/system/openvpn-client@.service ]]; then
   vpn_ser=openvpn
 fi
 
-s dd of=/etc/systemd/system/transmission-daemon-nn.service <<EOF
+s/etc/systemd/system/transmission-daemon-nn.service <<EOF
 [Unit]
 Description=Transmission BitTorrent Daemon netns
 After=network.target
@@ -1186,7 +1141,7 @@ EOF
 ser daemon-reload
 
 if [[ $HOSTNAME == frodo ]]; then
-  sgo transmission-daemon-nn
+  sgo transmission-daemon-nn
 fi
 
 
@@ -1219,7 +1174,8 @@ EOF
   rpc_pass=$(</p/transmission-rpc-pass)
   for f in /home/*; do
     u=${f##*/}
-    if [[ ! $(id -u $u) -ge 1000 ]]; then
+    uid=$(id -u $u 2>/dev/null) || continue
+    if [[ ! $uid -ge 1000 ]]; then
       continue
     fi
     d=$f/.config/transmission-remote-gtk
@@ -1257,27 +1213,10 @@ EOF
 fi
 ######### end transmission client setup ######
 
-# dunno why it\'s there, but get rid of it
-case $HOSTNAME in
-  li|lj) s rm -rf /home/linode ;;
-esac
-
 
 ### printer setup
-case $distro in
-  arch)
-    pi cups ghostscript gsfonts # from arch wiki cups page
-    pi hplip # from google
-    s gpasswd -a $USER sys # from arch wiki
-    sgo org.cups.cupsd.service
-    ;;
-  debian|trisquel|ubuntu)
-    pi cups
-    s gpasswd -a $USER lpadmin # based on ubuntu wiki
-    spa hplip
-    ;;
-  # other distros unknown
-esac
+pi cups hplip
+s gpasswd -a $USER lpadmin # based on ubuntu wiki
 # goto http://127.0.0.1:631
 # administration tab, add new printer button.
 # In debian, I could use hte recommended driver,
@@ -1291,7 +1230,7 @@ for x in iank user2; do s usermod -a -G libvirt,kvm $x; done
 # http://wiki.qemu.org/Features-Done/HelperNetworking
 # s mkdir /etc/qemu
 # f=/etc/qemu/bridge.conf
-# s dd of=$f <<'EOF'
+# s$f <<'EOF'
 # allow br0
 # EOF
 # #s chown root:qemu $f # debian has somethig like qemu-libvirt. equivalent?
@@ -1299,71 +1238,12 @@ for x in iank user2; do s usermod -a -G libvirt,kvm $x; done
 
 # general known for debian/ubuntu, not for fedora
 
-case $distro in
-  debian|trisquel|ubuntu)
-    if ! type -p go &>/dev/null; then
-      cd $(mktemp -d)
-      # just the latest stable at the time of writing
-      # TODO, maybe put this all into a build script,
-      # and do some automatic updates
-      wget -q https://dl.google.com/go/go1.12.4.linux-amd64.tar.gz
-      s tar -C /usr/local -xzf go1.12.4.linux-amd64.tar.gz
-      rm -f ./*
-    fi
-    go get -u mvdan.cc/fdroidcl
-    # a bit of googling, and added settings to bashrc
-    ;;
-esac
-
-case $distro in
-  arch)
-    pi virt-install
-    # otherwise we get error about accessing kvm module.
-    # seems like there might be a better way, but google was a bit vague.
-    s $sed -ri '/^ *user *=/d' /etc/libvirt/qemu.conf
-    echo 'user = "root"' | s tee -a /etc/libvirt/qemu.conf
-    # guessing this is not needed
-    #sgo virtlogd.service
-
-    # iank: disabed as im not using libvirt usually
-    # # https://bbs.archlinux.org/viewtopic.php?id=206206
-    # # # this should prolly go in the wiki
-    # sgo virtlogd.socket
-    # sgo libvirtd
-    ;;
-  debian|trisquel|ubuntu)
-    pi-nostart virtinst virt-manager
-    ;;
-
-esac
-
-
-case $distro in
-  fedora)
-    cd $(mktemp -d)
-    wget ftp://ftp.gnu.org/pub/gnu/global/global-6.5.7.tar.gz
-    ex global*
-    cd global-6.5.7
-    # based on https://github.com/leoliu/ggtags
-    ./configure --with-exuberant-ctags=/usr/bin/ctags
-    make
-    s make install
-    pip install pygments
-    ;;
-  *)
-    pi global
-    ;;&
-  arch)
-    pi  python2-pygments
-    ;;
-  debian|trisquel|ubuntu)
-    pi python-pygments
-    ;;
-esac
-
+m /a/bin/buildscripts/go
+m /a/bin/buildscripts/rust
+m /a/bin/buildscripts/misc
 
+pi-nostart virtinst virt-manager
 
-# removed synergy since ive not used it in a long time
 
 
 pi --no-install-recommends kdeconnect
@@ -1387,12 +1267,7 @@ pi --no-install-recommends kdeconnect
 # also built latest arduino in /a/opt/Arduino, (just cd build; ant build; ant run )
 # set arduino var in bashrc,
 # have system config file setup too.
-sudo adduser $USER dialout
-case $distro in
-  arch)
-    sudo usermod -a -G uucp $USER
-    ;;
-esac
+s adduser $USER dialout
 
 # this is for the mail command too. update-alternatives is kind of misleading
 # since at least it's main commands pretend mail does not exist.
@@ -1456,17 +1331,17 @@ fi
 # displays l and I as the same char, grrrrr.
 s fc-cache
 
-/a/bin/distro-setup/mymimes
+/a/bin/distro-setup/mymimes
 
 
-sgo dynamicipupdate
+sgo dynamicipupdate
 
 
 # stop autopoping windows when i plug in an android phone.
 # dbus-launch makes this work within an ssh connection, otherwise you get this message,
 # with still 0 exit code.
 # dconf-WARNING **: failed to commit changes to dconf: Cannot autolaunch D-Bus without X11 $DISPLAY
-dbus-launch gsettings set org.gnome.desktop.media-handling automount-open false
+dbus-launch gsettings set org.gnome.desktop.media-handling automount-open false
 
 
 # on grub upgrade, we get prompts unless we do this
@@ -1483,43 +1358,11 @@ EOF
 sgo btrfsmaint.timer
 sgo btrfsmaintstop.timer
 
-
-# the wiki backup script from ofswiki.org uses generic paths
-s lnf /p/c/machine_specific/li/mw_vars /root
-s lnf /k/backup/wiki_backup /root
-
-
-case $distro in
-  trisquel|ubuntu|debian)
-    # unison-gtk second, i want it to be default, not sure if that works
-    # with spa. note, I used to install from testing repo when using stable,
-    # but it shouldn't be needed since I wrote a script to handle mismatching
-    # compilers.
-    spa unison unison-gtk
-    ;;
-  arch)
-    spa unison gtk2
-    ;;
-esac
-
-case $distro in
-  arch)
-    # default is alsa, doesn\'t work with with pianobar
-    s dd of=/etc/libao.conf <<'EOF'
-default_driver=pulse
-EOF
-    ;;
-esac
-
-# # disabled due to my patch being in btrbk
-# case $distro in
-#     arch|debian|trisquel|ubuntu) pi btrbk ;;
-#     # others unknown
-# esac
-cd /a/opt/btrbk
+# aren't autoupdating this, but I do check on it somewhat regularly.
+m cd /a/opt/btrbk
 s make install
 
-sgo btrbk.timer
+sgo btrbk.timer
 # note: to see when it was last run,
 # ser list-timers
 
@@ -1529,121 +1372,36 @@ In mate settings settings, change scrolling to two-finger,
 because the default edge scroll doesn\'t work. Originally found this in debian.
 EOF
 
-case $distro in
-  debian)
-    # remove dep that came in with desktop
-    pu transmission-gtk
-    ;;
-esac
-
+# Remove dep that came in with desktop to fix associations.
+m pu transmission-gtk
 
-case $distro in
-  debian|trisquel|ubuntu) s gpasswd -a iank adm ;; #needed for reading logs
-esac
+s gpasswd -a iank adm #needed for reading logs
 
-/a/bin/buildscripts/pithosfly
-
-
-# based on guix manual instructions, also added code to profile
-pi nscd
-if ! type -p guix >/dev/null; then
-  cd $(mktemp -d)
-  wget https://git.savannah.gnu.org/cgit/guix.git/plain/etc/guix-install.sh
-  # added some stuff to envonment.sh for profile based on
-  # manual instructions
-  # wget https://sv.gnu.org/people/viewgpg.php?user_id=15145 -qO - | gpg --import -
-  # echo is to get past prompt
-  yes | sudo -E HOME=$HOME bash guix-install.sh || [[ $? == 141 ]]
-  guix install glibc-utf8-locales
-  guix package --install guile
-fi
+m /a/bin/buildscripts/pithosfly
 
-# install rust.
-curl https://sh.rustup.rs -sSf | bash -s -- -y
-# todo: update this. updates in rust are stupidly complicate
-if ! which rg &>/dev/null; then
-  cargo install ripgrep
-fi
 
-#### tor
-case $distro in
-  # based on
-  # https://www.torproject.org/docs/rpms.html.en
-  # https://www.torproject.org/docs/debian.html.en
-  # todo: figure out if the running service needs to be restarted upon updates
-  # todo on fedora: setup non-dev packages
-  fedora)
-    s dd of=/etc/yum.repos.d/torproject.repo <<'EOF'
-[tor]
-name=Tor experimental repo
-enabled=1
-baseurl=http://deb.torproject.org/torproject.org/rpm/tor-testing/fc/20/$basearch/
-gpgcheck=1
-gpgkey=http://deb.torproject.org/torproject.org/rpm/RPM-GPG-KEY-torproject.org.asc
-
-[tor-source]
-name=Tor experimental source repo
-enabled=1
-autorefresh=0
-baseurl=http://deb.torproject.org/torproject.org/rpm/tor-testing/fc/20/SRPMS
-gpgcheck=1
-gpgkey=http://deb.torproject.org/torproject.org/rpm/RPM-GPG-KEY-torproject.org.asc
-EOF
+# # Based on guix manual instructions, also added code to profile.
+# # disabled since i'm not using it now.
+# pi nscd
+# if ! type -p guix >/dev/null; then
+#   cd $(mktemp -d)
+#   wget https://git.savannah.gnu.org/cgit/guix.git/plain/etc/guix-install.sh
+#   # added some stuff to envonment.sh for profile based on
+#   # manual instructions
+#   # wget https://sv.gnu.org/people/viewgpg.php?user_id=15145 -qO - | gpg --import -
+#   # echo is to get past prompt
+#   yes | sudo -E HOME=$HOME bash guix-install.sh || [[ $? == 141 ]]
+#   guix install glibc-utf8-locales
+#   guix package --install guile
+# fi
 
-    # to be secure, take a look at the fingerprint reported from the following install, and see if it matches from the link above:
-    # 3B9E EEB9 7B1E 827B CF0A  0D96 8AF5 653C 5AC0 01F1
-    sgo tor
-    /a/bin/buildscripts/tor-browser
-    ;;
-  ubuntu)
-    tu /etc/apt/sources.list "deb http://deb.torproject.org/torproject.org $(debian-codename) main"
-    gpg --keyserver keys.gnupg.net --recv 886DDD89
-    gpg --export A3C4F0F979CAA22CDBA8F512EE8CBC9E886DDD89 | sudo apt-key add -
-    p update
-    pi deb.torproject.org-keyring
-    pi tor
-    /a/bin/buildscripts/tor-browser
-    ;;
-  debian)
-    pi tor
-    /a/bin/buildscripts/tor-browser
-    ;;
-  arch)
-    pi tor tor-browser-en
-    sgo tor
-    ;;
-  # ubuntu unknown
-esac
 
-# nfs server
-case $distro in
-  fedora)
-    end_msg <<'EOF'
-fedora todo: disable the firewall or find a way to automate it.
-there's an unused section in t.org for tramikssion firewall setup
-
-fedora manual config for nfs:
-s firewall-config
-change to permanent configuration
-check the box for nfs
-was hard to figure this out, not sure if this is all needed, but
-unblock these too
-mountd: udp/tcp 20048
-portmapper, in firewall-config its called rpc-bind: udp/tcp 111
-troubleshooting, unblock things in rpcinfo -p
-make sure to reload the firewall to load the persistent configuration
 
+pi tor
+m /a/bin/buildscripts/tor-browser
 
-EOF
-    pi nfs-utils
-    ;;
-  debian|trisquel|ubuntu)
-    pi-nostart nfs-server
-    ;;
-  arch)
-    pi nfs-utils || pending_reboot=true
-    ;;
-esac
+# nfs server
+pi-nostart nfs-kernel-server
 
 # networkmanager has this nasty behavior on flidas: if the machine
 # crashes with dnsmasq running, on subsequent boot, it adds an entry to
@@ -1670,7 +1428,6 @@ EOF
 fi
 
 
-e "$end_msg_var"
 
 
 
@@ -1684,11 +1441,4 @@ e "$end_msg_var"
 
 ######### begin stuff belonging at the end    ##########
 
-echo 0 >~/.local/distro-end
-if $pending_reboot; then
-  echo "$0: pending reboot and then finished. doing it now."
-  s reboot now
-else
-  echo "$0: $(date): ending now)"
-fi
-exit 0
+end